<?php
/*
Plugin Name: AskApache Password Protect
Plugin URI: http://www.askapache.com/wordpress/htaccess-password-protect.html
Description: Apache .htaccess Security: Password Protection and Advanced Security for your blog. <a href="options-general.php?page=askapache-password-protect.php">Configuration</a>
Version: 4.0.2
Author: AskApache
Author URI: http://www.askapache.com

== Installation ==
1. Extract zip in plugins directory
2. Activate the Plugin
3. Setup plugin options
*/



/*
/--------------------------------------------------------------------\
|                                                                    |
| License: GPL                                                       |
|                                                                    |
| AskApache Password Protect Plugin - Adds HTTP Basic Authentication |
| Copyright (C) 2008, AskApache, www.askapache.com                   |
| All rights reserved.                                               |
|                                                                    |
| This program is free software; you can redistribute it and/or      |
| modify it under the terms of the GNU General Public License        |
| as published by the Free Software Foundation; either version 2     |
| of the License, or (at your option) any later version.             |
|                                                                    |
| This program is distributed in the hope that it will be useful,    |
| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
| GNU General Public License for more details.                       |
|                                                                    |
| You should have received a copy of the GNU General Public License  |
| along with this program; if not, write to the                      |
| Free Software Foundation, Inc.                                     |
| 51 Franklin Street, Fifth Floor                                    |
| Boston, MA  02110-1301, USA                                        |
|                                                                    |
\--------------------------------------------------------------------/
*/
?>
<?php
define('AA_PP_DEBUG',0);
if(defined('AA_PP_ALREADY_INCLUDED'))return;
else define('AA_PP_ALREADY_INCLUDED','yessir');

if(!function_exists('aa_pp_options_setup1')){function aa_pp_options_setup1() {
	add_options_page('AskApache Password Protection', 'AA PassPro', 8, basename(__FILE__), 'aa_pp_main_page');
}}

function aa_pp_get_post_values(){
	global $aa_PP;
	$aa_PP=get_option('askapache_password_protect');

	if(isset($_POST['htaccessuser']) && $_POST['htaccessuser']!=$aa_PP['user']){
		$aa_PP['user']=$_POST['htaccessuser'];
		$aa_PP['change_htpasswd']='1';
	}

	if(isset($_POST['htaccesspass'])||isset($_POST['modifyuser'])) {
		$aa_PP['change_htpasswd']='1';
		$aa_PP['change_htaccess']='1';
		if(strlen($_POST['htaccesspass'])>1 && $_POST['htaccesspass'] != $aa_PP['pass'])if(aa_pp_notify_mail($aa_PP['user'],$_POST['htaccesspass']))echo '<h2>Sent Copy of old .htaccess to you</h2>';
	}

	if(isset($_POST['htaccessrealm']) && $_POST['htaccessrealm']!=$aa_PP['realm']){
		$aa_PP['realm']=$_POST['htaccessrealm'];
		if(strlen($aa_PP['realm'])>10)$aa_PP['realm']=substr($aa_PP['realm'], 0, 10);
		$aa_PP['change_htaccess']='1';
	}
			
			
	if(isset($_POST['htpasswdfile']) && $_POST['htpasswdfile']!=$aa_PP['htpasswd']) {
		if(is_writable(dirname($_POST['htpasswdfile'])) && touch($_POST['htpasswdfile'])){
			$aa_PP['htpasswd']=$_POST['htpasswdfile'];
			$aa_PP['change_htpasswd']='1';
		} else die($_POST['htpasswdfile'].' location is not writable!');
	}

			
	if(isset($_POST['aapassformat1']) && $_POST['aapassformat1']!=$aa_PP['format']){
		$aa_PP['format']=$_POST['aapassformat1'];
		$aa_PP['change_htpasswd']='1';
	}

	if(isset($_POST['aapassformat']) && $_POST['aapassformat']!=$aa_PP['format']){
		$aa_PP['format']=$_POST['aapassformat'];
		$aa_PP['change_htpasswd']='1';
	}

	if(AA_PP_DEBUG){echo '<pre>';print_r($_POST);echo '</pre>';}

	update_option('askapache_password_protect',$aa_PP);
}




// aa_pp_admin_header
function aa_pp_admin_header(){
	global $aa_PP;

	if (function_exists('current_user_can')&&!current_user_can(8)||!current_user_can('upload_files')) die(__("You are not allowed to be here"));
	$aa_PP=get_option('askapache_password_protect');

	$aa_PP['htaccessusers']=aa_pp_current_users($aa_PP['htpasswd'],'AskApache PassPro');
	

	if($_SERVER['REQUEST_METHOD']==='POST') 
	{
		check_admin_referer('askapache-password-protect-update_modify');
		aa_pp_get_post_values();
		
				
			if(	isset($_POST['sid1000']) || isset($_POST['sid1005']) || isset($_POST['sid1010']) || isset($_POST['sid1015']) || isset($_POST['sid1030']) || isset($_POST['sid1025'])){
				$aa_PP['ROOT_HTACCESS_ON']='true';
				$aa_PP['ROOT_HTACCESS_RULES']=array('',
				'<IfModule mod_rewrite.c>',
				'RewriteEngine On',
				'RewriteBase /',
				'');
			} else $aa_PP['ROOT_HTACCESS_ON']='false';
			
			if(isset($_POST['sid1015'])) {
				$aa_PP['S']['sid1015']['ON']='true';
				$aa_PP['S']['sid1015']['RULES']=array('# sid1015',
				'RewriteCond %{REQUEST_METHOD} !^(GET|POST|OPTIONS|PUT|HEAD)$ [NC]',
				'RewriteRule .* - [F,L]','# sid1015');
				$aa_PP['ROOT_HTACCESS_RULES']=array_merge($aa_PP['ROOT_HTACCESS_RULES'],$aa_PP['S']['sid1015']['RULES']);
			} else $aa_PP['S']['sid1015']['ON']='false';



			if(isset($_POST['sid1030'])) {
				$aa_PP['S']['sid1030']['ON']='true';
				$aa_PP['S']['sid1030']['RULES']=array('# sid1030',
				'RewriteCond %{HTTPS} !=on [NC]',
				'RewriteRule .* https://%{HTTP_HOST}%{REQUEST_URI} [R=301,L]','# sid1030');
				$aa_PP['S']['sid1030']['RULES']=array_merge($aa_PP['ROOT_HTACCESS_RULES'],$aa_PP['S']['sid1030']['RULES']);
			} else $aa_PP['S']['sid1030']['ON']='false';
			
			
			
				if(isset($_POST['sid1000'])) {
					$aa_PP['S']['sid1000']['ON']='true';
					$aa_PP['S']['sid1000']['RULES']=array('# sid1000',
					'RewriteCond %{THE_REQUEST} ^[A-Z]{3,9}\ '.$aa_PP['root_path'].'wp-content/.*$ [NC]',
					'RewriteCond %{REQUEST_FILENAME} ^.+\.php$',
					'RewriteRule .* - [F,NS]','# sid1000');
					$aa_PP['ROOT_HTACCESS_RULES']=array_merge($aa_PP['ROOT_HTACCESS_RULES'],$aa_PP['S']['sid1000']['RULES']);
				} else $aa_PP['S']['sid1000']['ON']='false';

				if(isset($_POST['sid1010'])) {
					$aa_PP['S']['sid1010']['ON']='true';
					$aa_PP['S']['sid1010']['RULES']=array('# sid1010',
					'RewriteCond %{THE_REQUEST} ^[A-Z]{3,9}\ '.$aa_PP['root_path'].'wp-includes/.*$ [NC]',
					'RewriteCond %{REQUEST_FILENAME} ^.+\.php$',
					'RewriteRule .* - [F,NS]','# sid1010');
					$aa_PP['ROOT_HTACCESS_RULES']=array_merge($aa_PP['ROOT_HTACCESS_RULES'],$aa_PP['S']['sid1010']['RULES']);
				} else $aa_PP['S']['sid1010']['ON']='false';

			if($aa_PP['ROOT_HTACCESS_ON']=='true'){
				$aa_PP['ROOT_HTACCESS_RULES'][]='';
				$aa_PP['ROOT_HTACCESS_RULES'][]='</IfModule>';
				$aa_PP['ROOT_HTACCESS_RULES'][]='';
			}


			if(isset($_POST['sid1005'])) {
				$aa_PP['S']['sid1005']['ON']='true';
				$aa_PP['S']['sid1005']['RULES']=array('# sid1005',
				'<Files wp-login.php>',
				'AuthName "'.$aa_PP['realm'].'"',
				'AuthUserFile '.$aa_PP['htpasswd'],
				'AuthType Basic',
				'Require valid-user',
				'</Files>','# sid1005');
				$aa_PP['ROOT_HTACCESS_RULES']=array_merge($aa_PP['ROOT_HTACCESS_RULES'],$aa_PP['S']['sid1005']['RULES']);
			} else $aa_PP['S']['sid1005']['ON']= 'false';

			if(isset($_POST['sid1025'])) {
				$aa_PP['S']['sid1025']['ON']='true';
				$aa_PP['S']['sid1025']['RULES']=array('# sid1025',
				'Options -Indexes',
				'DirectoryIndex '.$aa_PP['root_path'].'index.php','# sid1025');
				$aa_PP['ROOT_HTACCESS_RULES']=array_merge($aa_PP['ROOT_HTACCESS_RULES'],$aa_PP['S']['sid1025']['RULES']);
			} else $aa_PP['S']['sid1025']['ON']='false';

			
			
			if($aa_PP['ROOT_HTACCESS_ON']=='true'){
				$aa_PP['ROOT_HTACCESS_RULES'][]='';
				
				if(!aa_pp_insert_mark($aa_PP['ROOT_HTACCESS'], 'AskApache PassPro', $aa_PP['ROOT_HTACCESS_RULES']))	die("Couldnt create ".$aa_PP['ROOT_HTACCESS']." file!");
				
			}
			
			
			
			if(isset($_POST['sid900'])) {
				@ aa_pp_unlink($aa_PP['S']['sid900']['FILE']);
				$aa_PP['S']['sid900']['RULES']=array('# sid900',
				'AuthName "'.$aa_PP['realm'].'"',
				'AuthUserFile '.$aa_PP['htpasswd'],
				'AuthType Basic',
				'Require valid-user',
				'',
				'<FilesMatch "\.(ico|pdf|flv|jpg|jpeg|png|gif|swf|css|js)$">',
				'Allow from All',
				'</FilesMatch>',
				'',
				'<Files async-upload.php>',
				'Allow from All',
				'</Files>',
				'Satisfy Any','# sid900');
				if(!aa_pp_insert_mark($aa_PP['S']['sid900']['FILE'], 'AskApache PassPro', $aa_PP['S']['sid900']['RULES']))	die("Couldnt create ".$aa_PP['S']['sid900']['FILE']." file!");
				else $aa_PP['S']['sid900']['ON']='true';
			} else {
				@ aa_pp_unlink($aa_PP['S']['sid900']['FILE']);
				$aa_PP['S']['sid900']['ON']='false';
			}
			
			if($aa_PP['change_htpasswd']=='1' && strlen($_POST['htaccesspass'])>1){
				@ aa_pp_unlink($aa_PP['htpasswd']);
				$aa_PP['HTPASSWD_RULES']=array(aa_pp_hashit($aa_PP['format'],$aa_PP['user'],$_POST['htaccesspass']));
				
				if(!aa_pp_insert_mark($aa_PP['htpasswd'],'AskApache PassPro',$aa_PP['HTPASSWD_RULES'])) die('Error Creating '.$aa_PP['htpasswd']);
				else $aa_PP['change_htpasswd']='0';
			}
			
			

		if(isset($_POST['aapptestingdone']))$aa_PP['config_step']='2';
		if(isset($_POST['aappsetupcomplete']))$aa_PP['config_step']='3';
		
	}
	update_option('askapache_password_protect',$aa_PP);
}






// aa_pp_main_page
function aa_pp_main_page() {
	global $aa_PP;
	
	if (! user_can_access_admin_page()) die( __('You do not have sufficient permissions to access this page.') );
	if (function_exists('current_user_can')&&!current_user_can(8)||!current_user_can('upload_files'))die(__("You are not allowed to be here"));
	?>

	
    <p style="text-align:center; font-size:1.1em; background-color:#E4F2FD; border-top:1px solid #CCC; padding-top:10px; border-bottom:1px solid #CCC; padding-bottom:10px;"><?php echo $aa_PP['plugin_data']['Title'];?> <strong><?php echo $aa_PP['plugin_data']['Version'];?></strong> by <?php echo $aa_PP['plugin_data']['Author'];?>&nbsp;&nbsp;&nbsp;|&nbsp; <a href="http://www.askapache.com/seo/404-google-wordpress-plugin.html">Google 404 Plugin</a> - <a href="http://www.askapache.com/htaccess/apache-htaccess.html">.htaccess tutorial</a> - <a href="http://www.htaccesselite.com/">.htaccess help forum</a> </p><hr style="visibility:hidden;" />';
	
    <div class="wrap" style="min-width:600px;">
    <h2><?php echo $aa_PP['plugin_data']['Name']; ?></h2>
	<form action="<?php echo attribute_escape($_SERVER["REQUEST_URI"]); ?>" method="post"><?php wp_nonce_field('askapache-password-protect-update_modify'); ?>
	<?php if($aa_PP['config_step']!='1'){?><div class="updated fade-3366CC" id="message"><p>NOTE: This is an incredibly powerful plugin, and can easily take your site down.  If that happens, all you need to do is delete the .htaccess files on the server using ftp, ssh, whatev.</p></div><?php }?>
			
            
		<?php 

			if(AA_PP_DEBUG){
			echo '<pre>';
			print_r($aa_PP);$g=aa_pp_extract_mark(ABSPATH.'.htaccess','WordPress');print_r($g);
			if(function_exists('apache_get_modules'))print_r(apache_get_modules());
			ob_start();phpinfo(8);$g=ob_get_clean();echo $g;
			echo '</pre>';
			}
		?>


	<?php 
	if($aa_PP['config_step']=='1'){
		
		
		
		if($aa_PP['htaccess_support']=='0' || AA_PP_DEBUG){
			aa_pp_test_algorithms();
		} else {
	   		aa_pp_test_algorithms();
		}
		?>
        
        <p class="submit"><label><br /><input name="aapptestingdone" id="aapptestingdone" value="<?php _e('Continue to Setup &raquo;'); ?>" type="submit" class="button valinp" /></label></p>
        <p style="border-bottom:1px solid #CCC; padding:1em 0;"><br /></p>
        
		<?php
		
	}



	if($aa_PP['config_step']=='2'){
	?>
        
		<hr style="visibility:hidden;padding-top:.5em;clear:both;" /><div id="your-profile" style="min-width:300px;">
        <fieldset id="information" style="width:85%; float:none; margin:0 auto;">
		<legend>Installation</legend><hr style="visibility:hidden;padding-top:.5em;clear:both;" />
		<h3>Create User and Pass for .htpasswd</h3>
		<p><label>Pop-Up Message <em>Auth-Name / Realm</em>:<br /><input id="htaccessrealm" name="htaccessrealm" size="50" type="text" style="font-size:16px;" value="<?php echo $aa_PP['realm']; ?>" /></label></p>
		<p><label>Username:<br /><input id="htaccessuser" name="htaccessuser" size="16" type="text" style="font-size:16px;" value="<?php echo $aa_PP['user']; ?>" /></label></p>
		<p><label>Password:<br /><input id="htaccesspass" name="htaccesspass" size="16" type="text" style="font-size:16px;" value="<?php if(isset($_POST['htaccesspass'])) echo $_POST['htaccesspass'];else echo $aa_PP['pass'];; ?>" /></label></p>
		<?php aa_pp_show_encryptions('.htpasswd Encryption Settings:',0); ?>
		<p><label>.htpasswd location:<br /><input id="htpasswdfile" name="htpasswdfile" size="16" type="text" style="font-size:10px;" value="<?php echo $aa_PP['htpasswd']; ?>" /></label></p>

		<p class="submit"><label><br /><input name="aappsetupcomplete" id="aappsetupcomplete" value="<?php _e('Add User &raquo;'); ?>" type="submit" class="button valinp" /></label></p>
        <h4>AskApache PassPro Encryption Algorithm Descriptions</h4>
		<p><strong>CRYPT</strong><?php echo $aa_PP['algorithms']['CRYPT']['desc'];?></p>
		<p><strong>SHA1</strong><?php echo $aa_PP['algorithms']['SHA1']['desc'];?></p>
		<p><strong>MD5</strong><?php echo $aa_PP['algorithms']['MD5']['desc'];?></p>
		<p><strong>PLAIN TEXT</strong><?php echo $aa_PP['algorithms']['PLAIN']['desc'];?></p><hr style="visibility:hidden;padding-top:.25em;clear:both;" />

		<hr style="visibility:hidden;padding-top:1em;clear:both;" /></fieldset>
		</div><hr style="visibility:hidden;clear:both;" />
        
        
        
	<?php 
	} else if($aa_PP['config_step']=='3'){
	?>
    
		<hr style="visibility:hidden;padding-top:.5em;clear:both;" />
        
        <fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">Configurable .htaccess Security Modules</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<table class="widefat">
		<thead><tr>
		<th width="5%">SID</th>
		<th width="15%">Protection</th>
		<th width="50%">Description</th>
		<th width="15%">Response</th>
		<th style="text-align: center">Enable</th>
		</tr></thead>
		<tbody id="the-list">
        <?php
		$odd=' class="alternate"';
		foreach($aa_PP['S'] as $n=>$sid){?>
			<tr id="l-<?php echo $n;?>" valign="middle"<?php echo $odd;?>>
			<td><?php echo str_replace('sid','',$n);?></td>
            <td><strong><?php echo $sid['TITLE'];?></strong><br /></td>
			<td><?php echo $sid['DESC'];?></td>
			<td><?php echo $sid['RESP'];?></td>
			<td align='center'><input type="checkbox" name="<?php echo $n;?>" id="<?php echo $n;?>" <?php if($sid['ON']=='true')echo 'checked="checked" ';?> /></td>
			</tr>
		<?php	$odd=(!empty($odd)) ? ' class="alternate"' : ''; 
		}
		
		?>       
		</tbody></table>
        <p><label><br /><input name="updatemodules" id="updatemodules" value="<?php _e('Update Modules &raquo;'); ?>" type="submit" class="button valinp" /></label></p>
        <p>New modules added with every upgrade.  Submit your module suggestions/bugs <a href="http://www.askapache.com/about/contact/">here</a>.</p>
        </div></div></fieldset>
        
        <hr style="visibility:hidden;padding-top:.5em;clear:both;" /><div id="your-profile">
		<fieldset id="information" style="width:43%; float:left;">
		<legend>Modify .htaccess User</legend>
		<p><label>Auth Name:<br /><input id="htaccessrealm" name="htaccessrealm" size="50" type="text" style="font-size:15px;" value="<?php echo $aa_PP['realm']; ?>" /></label></p>
		<p><label>Username:<br /><input id="htaccessuser" name="htaccessuser" size="50" type="text" style="font-size:16px;" value="<?php echo $aa_PP['user']; ?>" /></label></p>
		<p><label>Password:<br /><input id="htaccesspass" name="htaccesspass" size="50" type="text" style="font-size:16px;" value="<?php if(isset($_POST['htaccesspass']))echo $_POST['htaccesspass']; ?>" /></label></p>
		<?php aa_pp_show_encryptions('.htpasswd Encryption Settings:',0); ?>
		<p><label>.htpasswd location:<br /><input id="htpasswdfile" name="htpasswdfile" size="16" type="text" style="font-size:10px;" value="<?php echo $aa_PP['htpasswd']; ?>" /></label></p>

		<p><label><br /><input name="modifyuser" id="modifyuser" value="<?php _e('Modify .htaccess User &raquo;'); ?>" type="submit" class="button valinp" /></label></p>
		<?php if($_SERVER['REQUEST_METHOD']!='GET')	{?><span style="visibility:hidden;overflow:hidden;display:block;width:1px;height:1px;background-image:url('askapache-<?php echo rand(1,1000);?>-.bmp');"></span><?php }?>
        </fieldset>
        
        
		<fieldset id="contact-info" style="width:33%; float:left;">
		<legend>Multi-Users.. Coming Soon</legend>
		<table class="widefat">
        <thead><tr>
		<th width="35%">Username</th>
		<th width="35%">Password</th>
		<th style="text-align: center">enabled</th>
		</tr></thead>
        
		<tbody id="the-list">
		<tr id="l-1" valign="middle">
		<td><?php echo $aa_PP['user']; ?><br /></td>
		<td><?php echo $aa_PP['format']; ?></td>
		<td align='center'>Yes</td>
		</tr>
        
        
		</tbody></table>
		<hr style="visibility:hidden;padding-top:.25em;clear:both;" /></fieldset><hr style="visibility:hidden;clear:both;" /></div><hr style="visibility:hidden;clear:both;" />
		<h3>Delete .htaccess files if you ever have a problem.</h3>
		<div id="advancedstuff" class="dbx-group" style="min-width:300px;">
		<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">View <?php echo basename($aa_PP['htpasswd']);?></h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<p class="desc"><?php echo $aa_PP['htpasswd']; ?></p>
		<pre style="width:80%; margin-left:2em;"><?php aa_pp_readfile($aa_PP['htpasswd']); ?></pre>
		</div></div></fieldset><hr style="visibility:hidden;clear:both;padding-top:.25em;" />

        <?php if($aa_PP['S']['sid900']['ON']=='true'){?>
		<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">View wp-admin .htaccess</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<p class="desc"><?php echo $aa_PP['S']['sid900']['FILE']; ?><br style="clear:both;" /></p>
		<pre style="width:80%; margin-left:2em;"><?php aa_pp_readfile($aa_PP['S']['sid900']['FILE']); ?></pre>
		</div></div></fieldset><hr style="visibility:hidden;clear:both;padding-top:.25em;" />
		<?php } ?>

        <?php if($aa_PP['ROOT_HTACCESS_ON']=='true'){?>
		<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">View root .htaccess</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<p class="desc"><?php echo $aa_PP['ROOT_HTACCESS']; ?><br style="clear:both;" /></p>
		<pre style="width:80%; margin-left:2em; overflow:auto;"><?php aa_pp_readfile($aa_PP['ROOT_HTACCESS']); ?></pre>
		</div></div></fieldset><hr style="visibility:hidden;clear:both;padding-top:.25em;" />
		<?php } ?>


		<?php /*<fieldset class="dbx-box"><div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">Set Default Password Encryption Algorithm</h3></div><div class="dbx-c-ontent-wrapper"><div class="dbx-content">
		<?php aa_pp_show_encryptions('Available Encryption Algorithms:',3); ?>
		</div></div></fieldset>*/?>
        <hr style="visibility:hidden;clear:both;padding-top:.25em;" />
        
		</div><hr style="visibility:hidden;clear:both;" />

		<?php
	}?>
    
	<hr style="visibility:hidden;clear:both;" />
	<div style="width:600px; margin:0 auto;">
    <div style="width:32%; overflow:hidden; float:left;"><h3 class="dbx-handle">About This Plugin</h3>
	<p><?php echo _e('Version:'); echo ' <strong>'.$aa_PP['plugin_data']['Version'].'</strong>'; ?></p>
	<p><?php echo _e('Info: '); echo str_replace($aa_PP['plugin_data']['Name'],'Plugin Homepage',$aa_PP['plugin_data']['Title']); ?></p>
	<p><?php _e('Author'); ?>: <?php echo $aa_PP['plugin_data']['Author']; ?></p></div>

	<div style="width:30%; overflow:hidden; float:left;"><h3 class="dbx-handle">AskApache Links</h3>
	<p>&middot; <a href="http://www.askapache.com/seo/404-google-wordpress-plugin.html">Google 401.php Plugin</a></p>
	<p>&middot; <a href="http://www.askapache.com/online-tools/htpasswd-generator/">.htpasswd Generator</a></p>
	<p>&middot; <a href="http://www.askapache.com/htaccess/apache-htaccess.html">htaccess tutorial</a></p></div>

	<div style="width:30%; overflow:hidden; float:left;"><h3 class="dbx-handle">Security Articles</h3>
	<p>&middot; <a href="http://codex.wordpress.org/Hardening_WordPress">Hardening WordPress</a></p>
	<p>&middot; <a href="http://www.askapache.com/htaccess/mod_security-htaccess-tricks.html">mod_security tricks</a></p>
	<p>&middot; <a href="http://codex.wordpress.org/Changing_File_Permissions">WordPress File Permissions</a></p></div><hr style="visibility:hidden;padding-top:.25em;clear:both;" /></div>
    </form></div><hr style="visibility:hidden;padding-top:.25em;clear:both;" />
	
	<?php	
}



function aa_pp_show_encryptions($label,$type=0){
	global $aa_PP;
	
	if($type==0){
       ?>
        <p><label><?php _e($label); ?><br />
		<select name="aapassformat" id="aapassformat">
		<option value="SHA1"<?php if($aa_PP['format']=='SHA1')echo ' selected="selected"';elseif($aa_PP['algorithms']['SHA1']['enabled']!='1')echo ' disabled="disabled"';?>>SHA1   </option>
        <option value="CRYPT"<?php if($aa_PP['format']=='CRYPT')echo ' selected="selected"';elseif($aa_PP['algorithms']['CRYPT']['enabled']!='1')echo ' disabled="disabled"';?>>CRYPT - Unix Only</option>
        <option value="MD5"<?php if($aa_PP['format']=='MD5')echo ' selected="selected"';elseif($aa_PP['algorithms']['MD5']['enabled']!='1')echo ' disabled="disabled"'?>>MD5 - Apache Only</option>
        <option value="PLAIN"<?php if($aa_PP['format']=='PLAIN')echo ' selected="selected"';elseif($aa_PP['algorithms']['PLAIN']['enabled']!='1')echo ' disabled="disabled"'?>>PLAIN - Win/BEOS</option>
		</select>
		</label></p>
        <?php
	} elseif($type==3){
	?>
		<p><label><?php _e($label); ?><br />
        <input id="aapassformat1" name="aapassformat1" type="hidden" value="<?php echo $aa_PP['format']; ?>" /></label></p>
		<ul>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatcrypt" type="radio" value="CRYPT" <?php if($aa_PP['format']=='CRYPT')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['CRYPT']['enabled']!='1')echo 'disabled="disabled"'; ?> /> <strong>CRYPT</strong> 
			<?php echo $aa_PP['algorithms']['PLAIN']['desc'];?></label></li>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatsha1" type="radio" value="SHA1" <?php if($aa_PP['format']=='SHA1')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['SHA1']['enabled']!='1')echo 'disabled="disabled"'; ?> /> <strong>SHA1</strong> 
			<?php echo $aa_PP['algorithms']['PLAIN']['desc'];?></label></li>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatmd5" type="radio" value="MD5" <?php if($aa_PP['format']=='MD5')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['MD5']['enabled']!='1')echo 'disabled="disabled"'; ?> /> <strong>MD5</strong> 
			<?php echo $aa_PP['algorithms']['PLAIN']['desc'];?></label></li>
		<li><label><input class="valinp" name="aapassformat1" id="aapassformatplain" type="radio" value="PLAIN" <?php if($aa_PP['format']=='PLAIN')echo 'checked="checked"'; 
		elseif($aa_PP['algorithms']['PLAIN']['enabled']!='1')echo 'disabled="disabled"'; ?> /> <strong>PLAIN TEXT</strong> 
			<?php echo $aa_PP['algorithms']['PLAIN']['desc'];?></label></li>
		</ul>
	<?php
	}
}



// aa_pp_unlink
function aa_pp_unlink($f) {
	@ unlink($f);
	if(!file_exists($f))return true;
	@ chmod($f,0777);
	@ unlink($f);if(!file_exists($f))return true;
	$stat = stat(dirname($f));
	$dir_perms = $stat['mode'] & 0007777;	
	@ chmod(dirname($f),$dir_perms);
	@ unlink($f);
	
	if(!file_exists($f))return true;
	else {
		die("Couldnt delete $f");
		return false;
	}
	if(AA_PP_DEBUG){aa_pp_mess('deleted '.$f);}

}





// aa_pp_file_put_c
function aa_pp_file_put_c($filename,$content){
	if (function_exists("file_put_contents")) {	@ file_put_contents($filename, $content); return true; }
	else {
		$fh = @ fopen($filename, 'wb');
		if ($fh) {
			@ fwrite($fh, $content);
			@ fclose($fh);
		} else return false;
	}
	if(AA_PP_DEBUG){aa_pp_mess('created '.$filename);}
	return true;
}

                

// aa_pp_readfile
function aa_pp_readfile($fn){
	if(file_exists($fn) && filesize($fn)>0) {
		if(!$f = @fopen($fn, 'rb'))return false;
		$filecontent = fread($f, filesize($fn));
		$filecontent = htmlspecialchars($filecontent);
	}
	else $filecontent = 'file does not exist!';
	if(fclose($f))echo $filecontent;
}


// aa_pp_mktempdir
function aa_pp_mktempdir($dirname,$prefix){
	$old=umask(0);
	$TRpdirname=tempnam(ABSPATH.'wp-content', $prefix);
	$stat = stat(ABSPATH.'wp-content');
	$dir_perms = $stat['mode'] & 0007777;
	@ chmod($TRpdirname, $dir_perms);
	aa_pp_unlink($TRpdirname);
	if (! mkdir($TRpdirname, 0777))	die("Error creating directory $dirname with $prefix");
	umask($old);
	if(AA_PP_DEBUG){aa_pp_mess('Created temporary directory at'.$TRpdirname);}
	return $TRpdirname;
}



function aa_pp_test_algorithms(){
	global $aa_PP;
	$e='eNqFUU1PwkAQvTfpfxgbDnCgQ40nKIsIGEhQG60HT2RpV7bhY9fdIRV/vdtSEi/E05vMvDdvJi8'.
	'eaanB99R6ZYkbancGvncvBc+FaQfzNE0wCiO460UwPpJUpvjhVKgDvIqvY2FEHnQG8EfxRpyOtv+vYMR'.
	'8L76ZvkzSj2QG8/RpCcn7w3IxgaCLuJilj4jTdHqe3IY9xNlzUGkk7Xc1OsMKqaCdYNftYjwzHBUvmrX'.
	'KT/WOiF0TuZEjaJYYRSIjkcP6BDEHacTnMJBEuo9YlmXI7ZZrnkkRZmqPpTK5NsJalMSzzBVdza2t2l1'.
	'9XhVWHwRsbLfjWgdJQ4DGyx0SI2cx6vroy7F4+bxKzPdam6HLbCNole0EP9S5iUwqaG2q6rugBurJiP0CaXaZXQ==';
	$t='eNrj5bKxL8go4OVyyEhNTEkt0lByzs8rSc0r0Q2pLEi1UsjMTUxP1U/PTFPStMaiyCc1L70kw0rBxBIsn5qcka9'.
	'QkJicraHkoaWko2RibmJpYmZsYWxpZmhgaGAAwpYgGgrSkABExMgwzdLAxMDU0ATEAaJkuGKofrC4kakJiG2cBLG2IrMESmmA+PZ2AEyvN7w=';
	
	$TRp=aa_pp_mktempdir(ABSPATH.'wp-content'.DIRECTORY_SEPARATOR, 'askapache');
	$TRpb=$aa_PP['root_path'].basename($TRp).DIRECTORY_SEPARATOR;
	$td=$aa_PP['root_path'].'wp-content'.DIRECTORY_SEPARATOR.basename($TRp).DIRECTORY_SEPARATOR.'test.php';

	$TRp1=aa_pp_mktempdir(ABSPATH.'wp-content'.DIRECTORY_SEPARATOR, 'askapache');
	$TRpb1=$aa_PP['root_path'].basename($TRp1).DIRECTORY_SEPARATOR;
	$td1=$aa_PP['root_path'].'wp-content'.DIRECTORY_SEPARATOR.basename($TRp1).DIRECTORY_SEPARATOR.'test.php';


	$g=array(
	aa_pp_hashit('CRYPT','testCRYPT','testCRYPT'),
	aa_pp_hashit('MD5','testMD5','testMD5'),
	aa_pp_hashit('SHA1','testSHA1','testSHA1'),
	aa_pp_hashit('PLAIN','testPLAIN','testPLAIN'));
	
	if(!aa_pp_insert_mark("$TRp".DIRECTORY_SEPARATOR.".htpasswda1", 'Test', $g)) die("Error Creating $TRp .htpasswda1 Test files!");

	$t1=gzuncompress(base64_decode($e));
	if(AA_PP_DEBUG){aa_pp_mess('Test File 401.php');aa_pp_mess('<pre>'.htmlentities($t1).'</pre>');}
	if(!aa_pp_file_put_c("$TRp".DIRECTORY_SEPARATOR."401.php",$t1)) die("Error Creating test pages for HTTP Authentication Enabled Test files!");
	if(!aa_pp_file_put_c("$TRp1".DIRECTORY_SEPARATOR."401.php",$t1)) die("Error Creating test pages for HTTP Authentication Enabled Test files!");

	$t2=ltrim(gzuncompress(base64_decode($t)));	
	if(AA_PP_DEBUG){aa_pp_mess('Test File test.php');aa_pp_mess('<pre>'.htmlentities($t2).'</pre>');}
	if(!aa_pp_file_put_c("$TRp".DIRECTORY_SEPARATOR."test.php",$t2)) die("Error Creating $TRp test.php for HTTP Authentication Enabled Test files!");
	if(!aa_pp_file_put_c("$TRp1".DIRECTORY_SEPARATOR."test.php",$t2)) die("Error Creating test pages for HTTP Authentication Enabled Test files!");
		
	$htaccessrules=array(
	"DirectoryIndex ".$TRpb."401.php 401.php",
	"ErrorDocument 401 ".$TRpb."401.php",
	"ErrorDocument 403 ".$TRpb."401.php",
	'AuthName "askapache test"',
	"AuthUserFile $TRp".DIRECTORY_SEPARATOR.".htpasswda1",
	"AuthType Basic",
	"Require valid-user");
	
	$htaccessrules1=array(
	"DirectoryIndex ".$TRpb1."401.php 401.php",
	"ErrorDocument 401 ".$TRpb1."401.php",
	"ErrorDocument 403 ".$TRpb1."401.php",
	"<IfModule mod_rewrite.c>",
	"RewriteEngine On",
	"RewriteBase /",
	'RewriteCond %{QUERY_STRING} !^$ [NC]',
	'RewriteRule .* /? [R,L]',
	"</IfModule>");

	if(!aa_pp_insert_mark("$TRp".DIRECTORY_SEPARATOR.".htaccess", 'Test', $htaccessrules)) die("Couldnt create $TRp".DIRECTORY_SEPARATOR.".htaccess file!");
	if(!aa_pp_insert_mark("$TRp1".DIRECTORY_SEPARATOR.".htaccess", 'Test', $htaccessrules1)) die("Couldnt create $TRp1".DIRECTORY_SEPARATOR.".htaccess file!");
	
	$rv=aa_pp_test_userpass(" "," ",$td1."?Q");
	echo "<h3>Testing server for mod_rewrite capability";if($rv=='302')echo ' <strong style="color:green;">[ GOOD!! ]</strong>';else echo ' <strong style="color:red;">[ BAD!! ]</strong>';echo "</h3>";
	echo '<p>Test returned: <a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-'.$rv.'">'.$rv;
	if(function_exists('get_status_header_desc'))echo ' '.get_status_header_desc($rv);		echo '</a></p>';
	
	foreach($aa_PP['algorithms'] as $key=>$value){
		$rg=aa_pp_test_userpass("test".$key,"test".$key,$td);
		$rb=aa_pp_test_userpass("fail".$key,"fail".$key,$td);
		sleep(1);
		
		if($rb=='401'){
			$aa_PP['algorithms'][$key]['enabled']='1';
			$aa_PP['htaccess_support']='1';
		} else $aa_PP['algorithms'][$key]['enabled']='0';	

		if($rg=='200'){
			$aa_PP['algorithms'][$key]['enabled']='1';
			$aa_PP['htaccess_support']='1';
		} else $aa_PP['algorithms'][$key]['enabled']='0';

		echo "<h3>Testing server for $key encryption capability";if($aa_PP['algorithms'][$key]['enabled']=='1')echo ' <strong style="color:green;">[ GOOD!! ]</strong>';else echo ' <strong style="color:red;">[ BAD!! ]</strong>';echo "</h3>";

		if($rg=='500' || $rb=='500')$aa_PP['htaccess_support']='0';
		echo '<p>Test returned: <a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-'.$rg.'">'.$rg;
		if(function_exists('get_status_header_desc'))echo ' '.get_status_header_desc($rg);		echo '</a></p>';
		echo '<p>Status Code Returned for BAD Test: <a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-'.$rb.'">'.$rb;
		if(function_exists('get_status_header_desc'))echo ' '.get_status_header_desc($rb);		echo '</a></p>';
	}

	aa_pp_clean_test(ABSPATH.'wp-content');	
	
	update_option('askapache_password_protect',$aa_PP);
	
	return true;
}




// aa_pp_test_userpass
function aa_pp_test_userpass($u,$p,$path){
	global $aa_PP;
	if ( !function_exists('fsockopen') )die('bad');
	$response_code=$response='';
	$UA='Mozilla/5.0 (compatible; AskApache/'.$aa_PP['plugin_data']['Version'].'; +http://www.askapache.com/)';
	$target=(isset($_SERVER["SERVER_ADDR"])) ? $_SERVER["SERVER_ADDR"] : gethostbyname($_SERVER['HTTP_HOST']);
	if(isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS'])=='on') {
		if(version_compare(phpversion(),'4.3.0','>=')&&function_exists('openssl_open')) $target="ssl://".$target.$_SERVER['SERVER_PORT'];
		else die('bad');
	}
	$usr=(strlen($u)>3) ? "Authorization: Basic ".base64_encode($u.":".$p)."\r\n\r\n" : "\r\n";
	$http_req=	"GET $path HTTP/1.1\r\n".
				"Host: ".$_SERVER['HTTP_HOST']."\r\n".
				"User-Agent: ".$UA."\r\n".
				"Accept: */*\r\n".
				"Referer: http://www.askapache.com\r\n".
				"Connection: Close\r\n".
				$usr;
				
	if(AA_PP_DEBUG){aa_pp_mess('<pre>Sending this request for the test</pre>');aa_pp_mess('<pre>'.htmlentities($http_req).'</pre>');}
	
	if( false!= ($fp = @fsockopen($target, $_SERVER['SERVER_PORT'], $errno, $errstr, 15)) && is_resource($fp)){
		@socket_set_timeout($fp,15);
		if(!fwrite($fp,$http_req,strlen($http_req)))die('bad');;
		do{
			$respons .= fgets($fp, 1160); 
			$fp_status = @socket_get_status($fp);
			if( $fp_status['timed_out'] ) break;
		}while (true && !feof($fp));

		if(@fclose($fp)){
			if(preg_match("|^HTTP/[^\s]*\s(.*?)\s|",$respons, $status))$response_code=$status[1];
			else return false;//return false; $respons;//die('garbled response!');
			$response = explode("\r\n\r\n", $respons, 2);
		}
	}else die('bad fsockopen');
	
	if(AA_PP_DEBUG){aa_pp_mess('<pre>'.htmlentities($respons).'</pre>');}
	
	return $response_code;
}



function aa_pp_current_users($HTPASS, $mark){
    $CURRENT_USERS=array();
	$cu=array();
    $cu=aa_pp_extract_mark($HTPASS, $mark);
    foreach($cu as $key){
        $CURRENT_USERS[]=preg_replace('/(.+):(.+)/', "\\1", $key, 1);
    }
	return array($CURRENT_USERS);
}


// aa_pp_hashit
function aa_pp_hashit($format,$user='',$pass=''){
	if(!function_exists('crypt') || !function_exists('sha1'))die("Error Creating .htpasswd hashes! Need crypt or sha1"); 
	$hash='';
	switch ($format){
		case 'PLAIN':
    		$hash=$user.':'.$pass;
			break;
		case 'CRYPT':
			$seed = NULL;
    		for ($i = 0; $i < 8; $i++) {$seed .= substr('0123456789abcdef', rand(0,15), 1);}
   			$hash=$user.':'.crypt($pass, "$1$".$seed);
			break;
		case 'SHA1':
			$hash=$user.':{SHA}'.base64_encode(pack("H*", sha1($pass)));
			break;
		case 'MD5': // php.net/crypt.php#73619
			$saltt = substr(str_shuffle("abcdefghijklmnopqrstuvwxyz0123456789"), 0, 8);
    		$len = strlen($pass);$text = $pass.'$apr1$'.$saltt;$bin = pack("H32", md5($pass.$saltt.$pass));
    		for($i = $len; $i > 0; $i -= 16) { $text .= substr($bin, 0, min(16, $i)); }
    		for($i = $len; $i > 0; $i >>= 1) { $text .= ($i & 1) ? chr(0) : $pass{0}; }
			$bin = pack("H32", md5($text));
    		for($i=0; $i<1000; $i++) { $new = ($i & 1) ? $pass : $bin; if ($i % 3) $new .= $saltt; if ($i % 7) $new .= $pass; $new .= ($i & 1) ? $bin : $pass; $bin = pack("H32", md5($new)); }
    		for($i=0; $i<5; $i++) { $k = $i + 6; $j=$i + 12; if($j==16){ $j = 5; } $TRp = $bin[$i].$bin[$k].$bin[$j].$TRp; }
    		$TRp = chr(0).chr(0).$bin[11].$TRp;
    		$TRp = strtr(strrev(substr(base64_encode($TRp), 2)),"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",
			"./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
    		$hash="$user:$"."apr1"."$".$saltt."$".$TRp;
			break;
	}
	if(AA_PP_DEBUG){aa_pp_mess('Created '.$format.' Hash for '.$user.' with Password '.$pass);aa_pp_mess('<pre>'.$hash.'</pre>');}
	return $hash;
}


function aa_pp_clean_test($path, $d=0){
   if (substr($path,strlen($path)-1)!= DIRECTORY_SEPARATOR) $path .= DIRECTORY_SEPARATOR;     
   if ($handle = opendir ($path)){
       while (false !== ($file=readdir($handle))){
           if ($file == '.' || $file == '..' || strpos($file,'askapache')===false && $d <= 0) continue;
           $file = $path.$file;
           if (!is_dir ($file) && !is_link($file)) @unlink($file);
		   elseif(!is_link($file)) { aa_pp_clean_test($file.DIRECTORY_SEPARATOR, $d+1);	@rmdir($file.DIRECTORY_SEPARATOR); }
       }
       closedir ($handle);
   }
	if(AA_PP_DEBUG){aa_pp_mess('Removed temporary test directory'.$path);}
}



function aa_pp_notify_mail($username,$pass){
	$result=false;
	if ( !is_object( $aappmailer ) || !is_a( $aappmailer, 'PHPMailer' ) && file_exists(ABSPATH . WPINC . '/class-phpmailer.php')) {
		require_once ABSPATH . WPINC . '/class-phpmailer.php';
		$aappmailer = new PHPMailer();
		
		$attach1=aa_pp_gzip(ABSPATH.'.htaccess',ABSPATH.'wp-admin'.DIRECTORY_SEPARATOR.'htaccess-backup.zip');
		
$message = sprintf("Your AskApache Protected WordPress blog has been modified, keep this email for your records. 

You can log in to the administrator account with the following information:

Username: %1\$s
Password: %2\$s

We hope you enjoy your new security. Thanks!

--AskApache
http://www.askapache.com/
",$username,$pass);
		$sitename = str_replace('www.','','wordpress@'.strtolower( $_SERVER['SERVER_NAME']));

		$user = wp_get_current_user();
		$aappmailer->ClearAddresses();
		$aappmailer->ClearAllRecipients();
		$aappmailer->ClearAttachments();
		$aappmailer->ClearBCCs();
		$aappmailer->ClearCCs();
		$aappmailer->ClearCustomHeaders();
		$aappmailer->ClearReplyTos();
		$aappmailer->FromName='WordPress';
		$aappmailer->From=$from_email;
		$aappmailer->AddAddress( $user->user_email );
		$aappmailer->Subject = '['.get_option('blogname').'] AskApache Password Protection';
		$aappmailer->Body = $message;
		$aappmailer->AddAttachment($attach1);
		$aappmailer->IsMail();
		$aappmailer->IsHTML( false );
		$aappmailer->CharSet=get_bloginfo( 'charset' );
		$result = @$aappmailer->Send();
	}
	aa_pp_unlink($attach1);
	return $result;
}


function aa_pp_generate_password($length = 12) {
	$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%";
	$p = '';
	for ( $i = 0; $i < $length; $i++ )$p .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
	return $p;
}


function aa_pp_mess($message=''){
	?>
	<div id="message" class="updated fade"><p><?php echo $message;?></p></div>
	<?php
}



function aa_pp_gzip($src, $dst){
	if(!is_readable($src) || !is_writable($dst) || !function_exists('gzopen'))return false;
	
	$fp = fopen($src, "rb");
  	$data = fread ($fp, filesize($src));
  	fclose($fp);

  	$zp = gzopen($dst, "w9");
  	gzwrite($zp, $data);
  	gzclose($zp);
	
	return $dst;
}


// Returns an array of strings from a file (.htaccess ) from between BEGIN
// and END markers.
function aa_pp_extract_mark( $filename, $marker ) {
	if (!file_exists($filename) || !is_readable($filename))return false;
	$result = array ();
	if ($markerdata = explode("\n", implode('',file($filename)))){
		$state = false;
		foreach ($markerdata as $markerline) {
			if (strpos($markerline,'# END '.$marker)!==false)$state = false;
			if ($state)$result[]=$markerline;
			if (strpos($markerline,'# BEGIN '.$marker)!==false)$state = true;
		}
	}
	return $result;
}

function aa_pp_insert_mark( $filename, $marker, $insertion ) {
	if (file_exists($filename) && !is_writable($filename) && @!chmod($filename,0666) && !touch($filename)) return false;
	if (!file_exists($filename) && is_writable(dirname($filename)) && touch($filename))$markerdata = '';
	else $markerdata = explode("\n", implode('',file($filename)));

	$f=fopen( $filename, 'w');
	$foundit = false;
	if ($markerdata) {
		$state = true;
		foreach ( $markerdata as $n => $markerline) {
			if (strpos($markerline,'# BEGIN '.$marker)!== false)$state = false;
			if($state) {
				if ($n+1 < count($markerdata))fwrite($f,"{$markerline}\n");
				else fwrite($f, "{$markerline}");
			}
			if (strpos($markerline, '# END ' . $marker) !== false) {
				fwrite($f,"# BEGIN {$marker}\n");
				if (is_array($insertion)) foreach ( $insertion as $insertline ) fwrite($f, "{$insertline}\n");
				fwrite($f, "# END {$marker}\n");
				$state=true;
				$foundit=true;
			}
		}
	}
	if (!$foundit) {
		fwrite($f,"\n# BEGIN {$marker}\n");
		foreach ($insertion as $insertline)fwrite($f, "{$insertline}\n");
		fwrite($f,"# END {$marker}\n");
	}
	fclose($f);
	return true;
}




// aa_pp_activate
function aa_pp_activate(){
	global $aa_PP;

	$oldoptions=array('aa_home_folder','aa_wpadmin_folder','aa_htpasswd_file','aa_htaccess_file','aa_original_htpasswd','aa_original_htaccess','aa_plugin_message','aa_plugin_version','aa_home','aa_wpadmin',
	'aa_htpasswd_f','aa_htaccess_f','aa_user','aa_plugin_message','aa_home_folder','aa_wpadmin_folder','aa_htpasswd_file','aa_htaccess_file','aa_original_htpasswd','aa_original_htaccess','aa_plugin_message',
	'aa_plugin_version','aa_pp_docROOT_HTACCESS','aa_pp_wp_sid900_FILE','aa_pp_wp_content_htaccess','aa_pp_wp_includes_htaccess','aa_pp_main_base64','aa_pp_ok','askapache_password_protect');
	foreach($oldoptions as $key){ delete_option($key); }
	
	$aa_PP['algorithms']=array(
	'CRYPT'	=>	array('enabled'=>0,'desc'=>' - Unix only. Uses the traditional Unix crypt function with a randomly-generated 32-bit salt.'),
	'MD5'	=>	array('enabled'=>0,'desc'=>' - Base64-encoded SHA-1 digest of the password.'),
	'SHA1'	=>	array('enabled'=>0,'desc'=>' - Apache-specific algorithm using an iterated MD5 digest of randoml 32-bit salt and the password.'),
	'PLAIN'	=>	array('enabled'=>0,'desc'=>' - (i.e. unencrypted) Windows, BEOS, &amp; Netware only')
	);
		
	// htpasswd settings
	$aa_PP['realm']='Protected By AskApache';
	$aa_PP['user']='admin';
	$aa_PP['format']='CRYPT';
	$aa_PP['pass']=aa_pp_generate_password();
	$aa_PP['htpasswd'] 			= ABSPATH.'.htpasswda1';
	$aa_PP['ROOT_HTACCESS'] 	= ABSPATH.'.htaccess';
	$aa_PP['ROOT_HTACCESS_ON'] 	='false';

	$aa_PP['S']['sid900']=array(
	'ON'=>'false',
	'TITLE'=>'wp-admin/*.*',
	'FILE'=>ABSPATH.'wp-admin'.DIRECTORY_SEPARATOR.'.htaccess',
	'RESP'=>'<a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-401">401</a>',
	'DESC'=>'Requires a valid user/pass to access any non-static (css, js, images) file in this directory');

	$aa_PP['S']['sid1000']=array(
	'ON'=>'false',
	'TITLE'=>'wp-content/*.php',
	'FILE'=>ABSPATH.'wp-content'.DIRECTORY_SEPARATOR.'.htaccess',
	'RESP'=>'<a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-401">401</a>',
	'DESC'=>'Denies any Direct request for files ending in .php with a 403 Forbidden'); 
	
	$aa_PP['S']['sid1005']=array(
	'ON'=>'false',
	'TITLE'=>'wp-login.php',
	'FILE'=>ABSPATH.'.htaccess',
	'RESP'=>'<a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-401">401</a>',
	'DESC'=>'Requires a valid user/pass to access the login page'); 
	
	$aa_PP['S']['sid1010']=array(
	'ON'=>'false',
	'TITLE'=>'wp-includes/*.php',
	'FILE'=>ABSPATH.'wp-includes'.DIRECTORY_SEPARATOR.'.htaccess',
	'RESP'=>'<a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-403">403</a>',
	'DESC'=>'Denies any Direct request for files ending in .php with a 403 Forbidden'); 
	
	$aa_PP['S']['sid1015']=array(
	'ON'=>'false',
	'TITLE'=>'REQUEST_METHODS',
	'FILE'=>ABSPATH.'.htaccess',
	'RESP'=>'<a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-403">403</a>',
	'DESC'=>'Denies any request not using <a href="http://www.askapache.com/online-tools/request-method-scanner/">!GET|POST|OPTIONS|PUT|HEAD</a>'); 
	
	$aa_PP['S']['sid1025']=array(
	'ON'=>'false',
	'TITLE'=>'Directory Protection',
	'FILE'=>ABSPATH.'.htaccess',
	'RESP'=>'<a href="http://www.askapache.com/htaccess/apache-htaccess.html">Disable</a>',
	'DESC'=>'Enable the DirectoryIndex Protection, preventing directory index listing'); 
	
	if($_SERVER['SERVER_PORT']!='80'||strtolower($_SERVER['HTTPS'])=='on'){
	$aa_PP['S']['sid1030']=array(
	'ON'=>'false',
	'TITLE'=>'SSL Site',
	'FILE'=>ABSPATH.'.htaccess',
	'RESP'=>'<a href="http://www.askapache.com/htaccess/apache-status-code-headers-errordocument.html#status-301">301</a>',
	'DESC'=>'Redirects all non-SSL (https) requests to your https url');
	} 
	
	// delete these old files
	if(is_file($aa_PP['S']['sid1010']['FILE'])) aa_pp_unlink($aa_PP['S']['sid1010']['FILE']);
	if(is_file($aa_PP['S']['sid1000']['FILE'])) aa_pp_unlink($aa_PP['S']['sid1000']['FILE']);
	if(is_file($aa_PP['htpasswd'])) aa_pp_unlink($aa_PP['htpasswd']);

	$u=parse_url(get_option('site_url'));
	if(!isset($u['path']))$u['path']=DIRECTORY_SEPARATOR;
	$u['path']=DIRECTORY_SEPARATOR.$u['path'].DIRECTORY_SEPARATOR;
	$aa_PP['root_path']=preg_replace('/(\/{2,4})/i',DIRECTORY_SEPARATOR,$u['path']);
	
	
	$aa_PP['change_htpasswd']='0';
	$aa_PP['change_htaccess']='0';
	$aa_PP['config_step']='1';
	$aa_PP['htaccess_support']='0';

	$aa_PP['plugin_data']=get_plugin_data(__FILE__);
	update_option('askapache_password_protect',$aa_PP);
}




// aa_pp_deactivate
function aa_pp_deactivate(){
	global $aa_PP;
	$aa_PP=get_option('askapache_password_protect');
	aa_pp_unlink($aa_PP['S']['sid900']['FILE']);
	aa_pp_unlink($aa_PP['htpasswd']);
	aa_pp_insert_mark($aa_PP['S']['sid1005']['FILE'], 'AskApache PassPro', array(''));
	delete_option('askapache_password_protect');
}





register_activation_hook(__FILE__, 'aa_pp_activate');
register_deactivation_hook(__FILE__, 'aa_pp_deactivate');
if( strpos($_SERVER['REQUEST_URI'], basename(__FILE__))!==false ) add_action('admin_head', 'aa_pp_admin_header');
add_action('admin_menu', 'aa_pp_options_setup1');
?>